/*
The following code is

© Andreas Amann, 2007-2011
http://andreasamann.com/

You may incorporate this code into your program(s) without restriction.
This code has been provided "AS IS" and the responsibility for its operation is yours.
You are not permitted to redistribute this code under my name after having made changes.
If you're going to redistribute the code, please make it clear that the code was descended
from my code, but that you've made changes.
*/

var SF_ = ( function() {
	// private
	var _frontWidth;
	var _frontHeight;
	var _quickSelectTimeout = null;
	
	var _populatePopups = function()
		{
			// remove all current popup content…
			while ($("leaguePopup").childNodes.length)
				$("leaguePopup").removeChild($("leaguePopup").childNodes[0]);
			while ($("favPopup").childNodes.length)
				$("favPopup").removeChild($("favPopup").childNodes[0]);
			while ($("stPopup").childNodes.length)
				$("stPopup").removeChild($("stPopup").childNodes[0]);
			// …and repopulate the popups based on the selected preferences
			var theDefs = SF_.defs[SF_.prefs.currentLeague];
			var currentOptGroup = null;
			// league selection popup
			for (var i in SF_.leagues[SF_.prefs.currentSport])
			{
				var this_league = SF_.leagues[SF_.prefs.currentSport][i];
				if (this_league.league && this_league.league != "WNBA")
				{
					currentOptGroup = $("leaguePopup").appendChild(document.createElement("optgroup"));
					currentOptGroup.label = this_league.popupName || this_league.league;
				}
				if (currentOptGroup)
					currentOptGroup.appendChild(new Option(this_league.fullName));
				else
					$("leaguePopup").appendChild(new Option(this_league.fullName));
			}
			if (SF_.prefs.favoriteLeagues.match(new RegExp("%" + SF_.prefs.currentSport)))
				$("leaguePopup").selectedIndex = parseInt(SF_.prefs.favoriteLeagues.match(new RegExp("%" + SF_.prefs.currentSport + ".*?%"))[0].split("|")[1]);
			else
				$("leaguePopup").selectedIndex = 0;
			var currentOptGroupTeams;
			var currentOptGroupStandings;
			var lastLevel1 = "";
			SF_.theStandings.getPolls();
			if (SF_.theStandings.standingsLinkList.length)
			{
				currentOptGroupStandings = $("stPopup").appendChild(document.createElement("optgroup"));
				currentOptGroupStandings.label = "Polls";
				for (var i in SF_.theStandings.standingsLinkList)
				{
					currentOptGroupStandings.appendChild(new Option(SF_.theStandings.standingsLinkList[i].name));
					SF_.theStandings.standingsLinkList[i] = SF_.theStandings.standingsLinkList[i].link;
				}
				currentOptGroupStandings = null;
			}
			// team and standings selection popups
			SF_.theScoreBoard.scoreboardMainLink = SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].link || "";
			for (var i = SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].startIndex || 0, len = SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].endIndex || SF_.teams[SF_.prefs.currentLeague].length - 1; i <= len; i++)
			{
				var this_team = SF_.teams[SF_.prefs.currentLeague][i];
				if (this_team.level2)
				{
					if (this_team.standingsInfo)
						SF_.theStandings.standingsLinkList.push(this_team.standingsInfo);
					currentOptGroupTeams = $("favPopup").appendChild(document.createElement("optgroup"));
					currentOptGroupTeams.label = theDefs.level2.optgroup ? (this_team.level2 + theDefs.level2.optgroup) : ((this_team.level1 || lastLevel1) + " " + this_team.level2);
					if (this_team.level1)
					{
						lastLevel1 = this_team.level1;
						if (currentOptGroupStandings && (theDefs.level1Standings || !currentOptGroupStandings.childNodes.length))
							currentOptGroupStandings.appendChild(new Option(theDefs.level1.name));
						currentOptGroupStandings = $("stPopup").appendChild(document.createElement("optgroup"));
						currentOptGroupStandings.label = this_team.level1 + " " + (theDefs.level1.optgroup || "");
					}
					if (this_team.level2 != " ")
						currentOptGroupStandings.appendChild(new Option(this_team.level2 + " " + (theDefs.level2.name || "")));
				}
				currentOptGroupTeams.appendChild(new Option(this_team.fullName));
			}
			if (theDefs.level1Standings || !currentOptGroupStandings.childNodes.length)
				currentOptGroupStandings.appendChild(new Option(theDefs.level1.name));
		};
	var _getTeamImages = function(favoriteTeam)
		{
			if (favoriteTeam < 0)
			{
				$("teamImageBack").src = $("teamImage").src = "dummy";
				$("teamImageBack").onmouseup = "";
				return;
			}
			switch (SF_.prefs.currentSport)
			{
				case "Baseball":
					if (SF_.prefs.currentLeague == "MLB")
						$("teamImageBack").src = "http://www.mlb.com/mlb/images/team_logos/100x100/" + (SF_.teams["MLB"][favoriteTeam].imgName || SF_.teams["MLB"][favoriteTeam].shortName) + ".gif";
					else
						$("teamImageBack").src = "http://web.minorleaguebaseball.com/milb/images/clubheaderlogos/t" + (SF_.teams[SF_.prefs.currentLeague][favoriteTeam].imgName || SF_.teams[SF_.prefs.currentLeague][favoriteTeam].shortName) + "_logo_lg.gif";
					break;
				case "Football":
					$("teamImageBack").src = "http://images.sportsline.com/images/" + (SF_.prefs.currentLeague == "NFL" ? "nfl" : "collegefootball") + "/gamecenter/helmets/" + SF_.teams[SF_.prefs.currentLeague][SF_.prefs.favoriteTeam].shortName + "L.gif";
					break;
				case "Hockey":
					$("teamImageBack").src = "http://www.nhl.com/images/logos/100/" + (SF_.teams[SF_.prefs.currentLeague][SF_.prefs.favoriteTeam].imgName || SF_.teams[SF_.prefs.currentLeague][SF_.prefs.favoriteTeam].shortName).toLowerCase() + ".gif";
					break;
				case "Basketball":
					var theLeague = "";
					switch (SF_.prefs.currentLeague)
					{
						case "NBA":
							theLeague = "nba";
							break;
						case "WNBA":
							theLeague = "wnba";
							break;
						case "NCAAB":
							theLeague = "collegebasketball";
							break;
					}
					$("teamImageBack").src = "http://images.sportsline.com/images/cbss/ui2/logos/" + theLeague + "/160x100/" + (SF_.teams[SF_.prefs.currentLeague][SF_.prefs.favoriteTeam].imgName || SF_.teams[SF_.prefs.currentLeague][SF_.prefs.favoriteTeam].shortName) + ".gif";
					break;
			}
			$("teamImage").src = $("teamImageBack").src;
			$("teamImageBack").onmouseup = function(){SF_.showTeamPage(favoriteTeam);}
			$s("teamImageBack").display = "block";
		};
	var _resizeComplete = function()
		{
			$s("frontContent").width = "";
			$s("ContentScrollbar").top = document.defaultView.getComputedStyle($("mainContent")).getPropertyValue("top");
			$s("ContentScrollbar").bottom = "1.5em";
			$s("mainContent").right = $s("standingsHeader").right = ($s("ContentScrollbar").visibility != "") ? (parseInt(document.defaultView.getComputedStyle($("ContentScrollbar")).getPropertyValue("right")) + 14) + "px" : "";
			// make sure that currently ongoing games are visible when scrollbar is shown
			if (SF_.prefs.currentDisplay == "scoreboard"
					&& SF_.theScoreBoard.firstLiveGame
					&& $s("ContentScrollbar").visibility != ""
					&& parseInt(document.defaultView.getComputedStyle($("mainContent")).getPropertyValue("height")) < SF_.theScoreBoard.firstLiveGame / 2 * parseInt(document.defaultView.getComputedStyle($("front")).getPropertyValue("font-size")))
				contentScrollArea.verticalScrollTo(SF_.theScoreBoard.firstLiveGame / 2 * parseInt(document.defaultView.getComputedStyle($("front")).getPropertyValue("font-size")));
			else
				contentScrollArea.verticalScrollTo(0);
			contentScroller.refresh();
			contentScrollArea.refresh();
			contentScrollArea.focus();
			$s("frontContent").visibility = "";
			SF_.inResize = false;
			WC_.refreshView();
		};
	var _setActiveStyleSheet = function(title)
		// dynamic stylesheet loading based on <http://stackoverflow.com/questions/574944/how-to-load-up-css-files-using-javascript/577002#577002>
		{
			var head  = document.getElementsByTagName('head')[0];
			for ( var eachSheet = 0; eachSheet < 4; eachSheet++  )
			{
				var sheetName = ["Baseball","Basketball","Football","Hockey"][eachSheet];
				if ( $(sheetName) != null )
					head.removeChild($(sheetName));
			}
			var link  = document.createElement("link");
			link.id   = title;
			link.rel  = "stylesheet";
			link.type = "text/css";
			link.href = "Styles/" + title + ".css";
			head.appendChild(link);
		};

	//public
	return {
		theScoreBoard:
			null,
		theStandings:
			null,
		inResize:
			false,
		ignoreMouseUp:
			false,
		fadeAnimation:
			null,
		currentPopup:
			"",
		prefs: 
			{
				// note: we cannot use arrays as they won't be saved to the prefs - favoriteLeagues and favoriteTeams are somewhat convoluted due to this…
				currentSport: null,
				favoriteLeagues: "",
				favoriteLeague: 0,
				currentLeague: null,
				currentDisplay: "scoreboard",
				favoriteTeams: "",
				favoriteTeam: -1,
				showGameDetails: true,
				useLargeFonts: false
			},
		load: function()
			{
				$("Version").innerHTML = WC_.getKeyValue("CFBundleGetInfoString").replace("\n","<br />");
				$("SportIcon").object = new AppleInfoButton($("SportIcon"), $("front"), "", "", SF_.showQuickSelect);
				contentScroller = new AppleVerticalScrollbar($("ContentScrollbar"));
				contentScrollArea = new AppleScrollArea($("mainContent"),contentScroller);
				contentScrollArea.scrollsHorizontally = false;
				contentScroller.setAutohide(true);
				WC_.setupVerticalScrollbar(contentScroller);
				// read our prefs
				SF_.prefs.showGameDetails = WC_.getInstancePref("showGameDetails");
				if (SF_.prefs.showGameDetails == null)
					SF_.prefs.showGameDetails = WC_.getPref("showGameDetails", true);
				SF_.prefs.useLargeFonts = WC_.getInstancePref("useLargeFonts");
				if (SF_.prefs.useLargeFonts == null)
					SF_.prefs.useLargeFonts = WC_.getPref("useLargeFonts", false);
				SF_.prefs.currentDisplay = WC_.getInstancePref("currentDisplay","scoreboard");
				SF_.prefs.favoriteLeagues = WC_.getInstancePref("favoriteLeagues") || WC_.getPref("favoriteLeagues","");
				SF_.prefs.favoriteTeams = WC_.getInstancePref("favoriteTeams") || WC_.getPref("favoriteTeams","");
				SF_.prefs.currentSport = WC_.getInstancePref("currentSport");
				if (!SF_.prefs.currentSport)
				// we opened a new instance of the widget - show the back to allow for selection of prefs
					SF_.showBack();
				else
				{
					var theSport = SF_.prefs.currentSport;
					SF_.prefs.currentSport = "";
					SF_.changeSport(theSport);
					SF_.show();
				}
			},
		remove: function()
			{
				WC_.setInstancePref("currentDisplay", null);
				WC_.setInstancePref("currentSport", null);
				WC_.setInstancePref("favoriteLeagues", null);
				WC_.setInstancePref("favoriteTeams", null);
				WC_.setInstancePref("showGameDetails", null);
				WC_.setInstancePref("useLargeFonts", null);
				SF_.hide();
			},
		hide: function()
			{
				$s("quickSelect").visibility = "";
				SF_.hidePopup();
				WC_.stopSpinner("ReloadSpinner");
				$s("info").visibility = "";
				$s("SportIcon").visibility = "";
				if (_quickSelectTimeout != null)
					clearTimeout(_quickSelectTimeout);
				_quickSelectTimeout = null;
				SF_.abortOngoingRequests();
			},
		show: function()
			{
				var _self = SF_.prefs.currentDisplay == "scoreboard" ? SF_.theScoreBoard : SF_.theStandings;
				if (_self && _self.reloadTimer != null)
					return;
				if (SF_.prefs.currentLeague && SF_.prefs.currentLeague != "" && SF_.prefs.favoriteTeam > SF_.teams[SF_.prefs.currentLeague].length)
					SF_.prefs.favoriteTeam = -1;
				_getTeamImages(SF_.prefs.favoriteTeam);
				if (SF_.prefs.currentDisplay == "scoreboard")
				{
					if (SF_.theScoreBoard && SF_.theScoreBoard.nextReload && SF_.theScoreBoard.nextReload > new Date().getTime())
						SF_.theScoreBoard.draw();
					else
						if (SF_.theScoreBoard) SF_.theScoreBoard.load();
				}
				else
					if (SF_.theStandings) SF_.theStandings.load();
			},
		showBack: function(event)
			{
				var _self = SF_.prefs.currentDisplay == "scoreboard" ? SF_.theScoreBoard : SF_.theStandings;
				SF_.hide();
				if (_self && _self.xmlRequest)
				{
					_self.xmlRequest.abort();
					_self.xmlRequest = null;
				}
				if (SF_.prefs.currentSport)
					$s("icon_" + SF_.prefs.currentSport).cssText = "opacity:1;border:rgba(255,255,255,.5) 2px solid;background-color:rgba(255,255,255,.5);";
				else
				{
					$s("leaguePopupContainer").visibility = $s("favPopupContainer").visibility = $s("favLabel").visibility = $s("popupBoxDiv").visibility = $s("done").visibility = "hidden";
					$s("helpText").visibility = "visible";
				}
				if (SF_.prefs.favoriteTeam >= 0)
				{
					$("favPopup").selectedIndex = SF_.prefs.favoriteTeam - (SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].startIndex || 0);
					$("favText").innerText = $("favPopup").value;
				}
				else
					$("favText").innerText = "Please Select";
				$("popupBox").checked = SF_.prefs.showGameDetails;
				$("fontSizeBox").checked = SF_.prefs.useLargeFonts;
				
				if (window.widget)
					widget.prepareForTransition("ToBack");
					
				SF_.doResize(null,{right:WC_.getKeyValue("Width"),bottom:WC_.getKeyValue("Height")},null,null);
				
				$s("info").visibility = "";

				$s("front").display = "none";
				$s("back").display = "block";
				
				if (window.widget)
					setTimeout('widget.performTransition();', 0);

				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
			},
		showFront: function(event)
			{
				SF_.prefs.showGameDetails = $("popupBox").checked;
				WC_.setInstancePref("showGameDetails", SF_.prefs.showGameDetails);
				WC_.setPref("showGameDetails", SF_.prefs.showGameDetails);
				SF_.prefs.useLargeFonts = $("fontSizeBox").checked;
				WC_.setInstancePref("useLargeFonts", SF_.prefs.useLargeFonts);
				WC_.setPref("useLargeFonts", SF_.prefs.useLargeFonts);
				
				SF_.doResize(null,{right:WC_.getKeyValue("Width"),bottom:WC_.getKeyValue("Height")},null,null);

				$s("info").visibility = $s("SportIcon").visibility = "";
				$s("ContentScrollbar").visibility = "";
				$("mainContent").innerHTML = "";
				$("standingsHeader").innerHTML = "";
				$s("standingsFooter").visibility = "";
				$s("frontContent").visibility = "hidden";

				if (window.widget)
					widget.prepareForTransition("ToFront");

				// prevent calling of sizeWidget() before the flip is complete
				SF_.inResize = true;
				SF_.show();

				$s("front").display = "block";
				$s("back").display = "none";
				
				if (window.widget)
					setTimeout('widget.performTransition();SF_.inResize=false;', 0);
				setTimeout('SF_.hidePopup();SF_.sizeWidget();', 1000);

				if (event) {
					event.stopPropagation();
					event.preventDefault();
				}
			},
		closePopup: function(_self)
			{
				SF_.currentPopup = "";
				if (!_self && SF_.prefs.currentDisplay == "scoreboard")
					_self = SF_.theScoreBoard;
				else if (!_self)
					_self = SF_.theStandings;
				$("gameDetails").onmouseover = "";
				$("mainContent").innerHTML = $("mainContent").innerHTML.replace(/ selected/g,"");
				if (!_self || !_self.popupTimer) return;
				clearTimeout(_self.popupTimer);
				_self.popupTimer = null;
				SF_.fadeAnimation = new AppleAnimator(500, 13, 1, 0, SF_.fadePopup);
				SF_.fadeAnimation.oncomplete = SF_.hidePopup;
				SF_.fadeAnimation.start();
			},
		hidePopup: function()
			{
				$s("gameDetails").opacity = $s("gameDetails").visibility = "";
				// make sure we remove the bball base display if we showed that before
				$("gameDetails").innerHTML = "<div id='scoreDetails'> </div>";
				WC_.refreshView();
			},
		changeSport: function(theSport)
			{
				if (theSport == SF_.prefs.currentSport) return;
				$s("teamImageBack").display = "none";
				SF_.hidePopup();
				if (SF_.prefs.currentSport != "")
					SF_.prefs.currentDisplay = "scoreboard";
				SF_.prefs.currentSport = theSport;
				WC_.setInstancePref("currentSport",SF_.prefs.currentSport);
				WC_.setInstancePref("currentDisplay",SF_.prefs.currentDisplay);
				_setActiveStyleSheet(SF_.prefs.currentSport);
				for (var i = 0; i < 4; i++)
				{
					var eachElement = ["Baseball","Football","Basketball","Hockey"][i];
					$s("icon_" + eachElement).cssText = (SF_.prefs.currentSport == eachElement) ? "opacity:1;border:rgba(255,255,255,.5) 2px solid;background-color:rgba(255,255,255,.5);" : "";
				}
				SF_.prefs.currentLeague = null;
				if (SF_.prefs.favoriteLeagues.match(new RegExp("%" + SF_.prefs.currentSport)))
					SF_.prefs.favoriteLeague = parseInt(SF_.prefs.favoriteLeagues.match(new RegExp("%" + SF_.prefs.currentSport + ".*?%"))[0].split("|")[1]);
				else
					SF_.prefs.favoriteLeague = 0;
				for (var i = 0, len = SF_.prefs.favoriteLeague; i <= len; i++)
					SF_.prefs.currentLeague = SF_.leagues[SF_.prefs.currentSport][i].league || SF_.prefs.currentLeague || SF_.leagues[SF_.prefs.currentSport][i].fullName;
				// remove info button so we can change its color depending on the current sport later
				$("info").innerHTML = "";
				SF_.theScoreBoard = SF_.theStandings = null;
				switch(SF_.prefs.currentSport)
				{
					case "Baseball":
						$("info").object = new AppleInfoButton($("info"), $("front"), "white", "white", SF_.showBack);
						SF_.theScoreBoard = new SF_._scoreBoard("MLB");
						SF_.theStandings = new SF_._standings("MLB");
						_frontWidth = 287;
						_frontHeight = 180;
						break;
					case "Football":
						$("info").object = new AppleInfoButton($("info"), $("front"), "white", "white", SF_.showBack);
						SF_.theScoreBoard = new SF_._scoreBoard("NFL");
						SF_.theStandings = new SF_._standings("NFL");
						_frontWidth = 341;
						_frontHeight = 214;
						break;
					case "Hockey":
						$("info").object = new AppleInfoButton($("info"), $("front"), "white", "black", SF_.showBack);
						SF_.theScoreBoard = new SF_._scoreBoard("NHL");
						SF_.theStandings = new SF_._standings("NHL");
						_frontWidth = 287;
						_frontHeight = 178;
						break;
					case "Basketball":
						$("info").object = new AppleInfoButton($("info"), $("front"), "black", "black", SF_.showBack);
						SF_.theScoreBoard = new SF_._scoreBoard("NBA");
						SF_.theStandings = new SF_._standings("NBA");
						_frontWidth = 341;
						_frontHeight = 197;
						break;
				}
				$("SportIcon").object._flipLabel.src = "Images/Icons/" + SF_.prefs.currentSport + ".png";
				if (SF_.prefs.currentSport != "Football")
				// we use a three-picture font image for football defined by the HTML/CSS - no need to swap frontImg.src
					$("frontImg").src = "Images/Backgrounds/" + SF_.prefs.currentSport + ".png";
				_populatePopups();
				if (SF_.prefs.currentDisplay != "scoreboard")
					$("stPopup").selectedIndex = SF_.prefs.currentDisplay;
				$("leaguePopup").selectedIndex = SF_.prefs.favoriteLeague;
				$("leagueText").innerText = ($("leaguePopup").value == SF_.prefs.currentLeague ? "" : SF_.prefs.currentLeague + " - ") + $("leaguePopup").value;
				if (SF_.prefs.favoriteTeams.match(new RegExp("%" + SF_.prefs.currentLeague + "." + SF_.prefs.favoriteLeague + ":")))
					SF_.prefs.favoriteTeam = parseInt(SF_.prefs.favoriteTeams.replace(new RegExp(".*%" + SF_.prefs.currentLeague + "." + SF_.prefs.favoriteLeague + ":"),""));
				else
					SF_.prefs.favoriteTeam = -1;
				if (SF_.prefs.favoriteTeam != -1)
				{
					$("favPopup").selectedIndex = SF_.prefs.favoriteTeam - (SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].startIndex || 0);
					$("favText").innerText = $("favPopup").value;
				}
				SF_.changeTeam(true);
				$s("leaguePopupContainer").visibility = $s("favPopupContainer").visibility = $s("favLabel").visibility =$s("popupBoxDiv").visibility = $s("helpText").visibility = $s("done").visibility = "";
				return null;
			},
		switchSport: function(theSport)
			{
				if (_quickSelectTimeout != null)
					clearTimeout(_quickSelectTimeout);
				_quickSelectTimeout = null;
				$s("quickSelect").visibility = "";
				if (theSport == SF_.prefs.currentSport) return;
				$("teamImage").src = "dummy";
				var temp = SF_.abortOngoingRequests();
				$s("SportIcon").display = "none";
				$("mainContent").innerHTML = $("standingsHeader").innerHTML = $("standingsFooter").innerHTML = "";
				$("ContentScrollbar").visibility = "";
				temp = SF_.changeSport(theSport);
				SF_.doResize(null,{right:_frontWidth,bottom:_frontHeight},null,null);
				SF_.theScoreBoard.load();
			},
		showQuickSelect: function()
			{
				$s("quickSelect").visibility = "visible";
				quickSelectTimeout = setTimeout('$s("quickSelect").visibility = "";', 10000);
			},
		changeLeague: function()
			{
				if (SF_.prefs.favoriteLeague == $("leaguePopup").selectedIndex) return;
				SF_.prefs.favoriteLeague = $("leaguePopup").selectedIndex;
				SF_.theScoreBoard.gameSortOrder = [];
				SF_.theScoreBoard.gameDates = [];
				SF_.theScoreBoard.scoreBoardLink = null;
				SF_.theScoreBoard.nextReload = new Date().getTime();
				SF_.prefs.favoriteLeagues = SF_.prefs.favoriteLeagues.replace(new RegExp("%" + SF_.prefs.currentSport + ".*?%"),"") + "%" + SF_.prefs.currentSport + "|" + SF_.prefs.favoriteLeague + "%";
				var oldLeague = SF_.prefs.currentLeague;
				SF_.prefs.currentLeague = null;
				for (var i = 0, len = SF_.prefs.favoriteLeague; i <= len; i++)
					SF_.prefs.currentLeague = SF_.leagues[SF_.prefs.currentSport][i].league || SF_.prefs.currentLeague || SF_.leagues[SF_.prefs.currentSport][i].fullName;
				WC_.setInstancePref("favoriteLeagues",SF_.prefs.favoriteLeagues);
				WC_.setPref("favoriteLeagues",SF_.prefs.favoriteLeagues);
				$("leagueText").innerText = ($("leaguePopup").value == SF_.prefs.currentLeague ? "" : SF_.prefs.currentLeague + " - ") + $("leaguePopup").value;
				_populatePopups();
				var oldFav = SF_.prefs.favoriteTeam;
				if (SF_.prefs.favoriteTeams.match(new RegExp("%" + SF_.prefs.currentLeague + "." + SF_.prefs.favoriteLeague + ":")))
					SF_.prefs.favoriteTeam = parseInt(SF_.prefs.favoriteTeams.replace(new RegExp(".*%" + SF_.prefs.currentLeague + "." + SF_.prefs.favoriteLeague + ":"),""));
				else
					SF_.prefs.favoriteTeam = null;
				if (SF_.prefs.favoriteTeam == null)
				{
					if (SF_.prefs.currentLeague == oldLeague
						&& oldFav - (SF_.leagues[SF_.prefs.currentSport][SF_.prefs.favoriteLeague].startIndex || 0) >= 0
						&& oldFav - (SF_.leagues[SF_.prefs.currentSport][SF_.prefs.favoriteLeague].endIndex || SF_.teams[SF_.prefs.currentLeague].length) < 0
					)
						SF_.prefs.favoriteTeam = oldFav;
					else
						SF_.prefs.favoriteTeam = -1;
				}
				if (SF_.prefs.favoriteTeam != -1)
				{
					$("favPopup").selectedIndex = SF_.prefs.favoriteTeam - (SF_.leagues[SF_.prefs.currentSport][SF_.prefs.favoriteLeague].startIndex || 0);
					$("favText").innerText = $("favPopup").value;
				}
				SF_.changeTeam(true);
				SF_.prefs.currentDisplay = "scoreboard";
			},
		changeTeam: function(forceChange)
			{
				forceChange = forceChange || false;
				if (!forceChange && SF_.prefs.favoriteTeam == ($("favPopup").selectedIndex + (SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].startIndex || 0)))
					return;
				if ($("favPopup").value == "" || (forceChange && SF_.prefs.favoriteTeam == -1))
				{
					forceChange = true;
					SF_.prefs.favoriteTeam = -1;
				}
				else
				{
					$("favText").innerText = $("favPopup").value;
					SF_.prefs.favoriteTeam = $("favPopup").selectedIndex + (SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].startIndex || 0);
				}
				if (forceChange && SF_.prefs.favoriteTeam == -1)
					$("favText").innerText = "Please Select";
				else
					SF_.prefs.favoriteTeam = $("favPopup").selectedIndex + (SF_.leagues[SF_.prefs.currentSport][$("leaguePopup").selectedIndex].startIndex || 0);
				if (SF_.prefs.favoriteTeam != -1)
				{
					SF_.prefs.favoriteTeams = SF_.prefs.favoriteTeams.replace(new RegExp("(%" + SF_.prefs.currentLeague + "." + ($("leaguePopup").selectedIndex || 0) + ":.*?%)"),"");
					SF_.prefs.favoriteTeams += "%" + SF_.prefs.currentLeague + "|" + ($("leaguePopup").selectedIndex || 0) + ":" + SF_.prefs.favoriteTeam + "%";
					WC_.setInstancePref("favoriteTeams", SF_.prefs.favoriteTeams);
					WC_.setPref("favoriteTeams", SF_.prefs.favoriteTeams);
					if (SF_.prefs.currentDisplay == "scoreboard" && SF_.prefs.currentSport == "Baseball" && SF_.prefs.currentLeague != "MLB")
					// since we mark games with our favorite team in the parse() routine for minor league baseball, we will have to reload the scoreboard
						SF_.theScoreBoard.nextReload = new Date().getTime();
				}
				_getTeamImages(SF_.prefs.favoriteTeam);
			},
		getTeamIndex: function(theKey, theValue)
			{
				var i = 0;
				var currentValue;
				while (i < SF_.teams[SF_.prefs.currentLeague].length)
				{
					switch (theKey)
					{
						case "shortName":
							currentValue = (SF_.prefs.currentSport == "Baseball" ? SF_.teams[SF_.prefs.currentLeague][i].imgName : null) || SF_.teams[SF_.prefs.currentLeague][i].shortName;
							break;
						case "fullName":
							currentValue = SF_.teams[SF_.prefs.currentLeague][i].fullName;
							break;
						case "imgName":
							currentValue = SF_.teams[SF_.prefs.currentLeague][i].imgName;
							break;
						case "nickname":
							currentValue = SF_.teams[SF_.prefs.currentLeague][i].nickName || SF_.teams[SF_.prefs.currentLeague][i].fullName.replace(/.* /,"").toLowerCase();
							break;
					}
					if (currentValue == theValue) break;
					i++;
				}
				return (currentValue == theValue ? i : -1);
			},
		doResize: function(rectAnimation, currentRect, startingRect, finishingRect)
			{
				$s("frontImg").width = $s("frontImgTop").width = $s("frontImgBottom").width = $s("middleImg").width = $s("frontImgMiddle").width = currentRect.right + "px";
				$s("frontImgTop").height = $s("frontImgMiddle").top = currentRect.right/341*95 + "px";
				$s("frontImgBottom").height = currentRect.right/341*92 + "px";
				$s("middleImg").height = (currentRect.bottom - parseInt($s("frontImgTop").height) - parseInt($s("frontImgBottom").height)) + "px";
				$s("frontImg").height = currentRect.bottom + "px";
				if (this.to && this.to.right == this.from.right && this.to.bottom != this.from.bottom)
				// purely vertical resizing does not work in 10.4 Dashboard
				{
					$s("frontContent").width = $("frontContent").offsetWidth + "px";
					window.resizeTo(currentRect.right-1, currentRect.bottom);
				}
				window.resizeTo(currentRect.right, currentRect.bottom);
				WC_.refreshView();
			},
		abortOngoingRequests: function()
			{
				SF_.hidePopup();
				if (SF_.theScoreBoard)
				{
					SF_.theScoreBoard.cancelScoreUpdates();
					if (SF_.theScoreBoard.xmlRequest)
					{
						SF_.theScoreBoard.xmlRequest.abort();
						SF_.theScoreBoard.xmlRequest = null;
					}
					if (SF_.theScoreBoard.reloadTimer != null)
					{
						clearTimeout(SF_.theScoreBoard.reloadTimer);
						SF_.theScoreBoard.reloadTimer = null;
					}
					if (SF_.theScoreBoard.xmlPlaysRequest)
					{
						SF_.theScoreBoard.xmlPlaysRequest.abort();
						SF_.theScoreBoard.xmlPlaysRequest = null;
					}
				}
				if (SF_.theStandings)
				{
					if (SF_.theStandings.xmlRequest)
					{
						SF_.theStandings.xmlRequest.abort();
						SF_.theStandings.xmlRequest = null;
					}
					if (SF_.theStandings.reloadTimer != null)
					{
						clearTimeout(SF_.theStandings.reloadTimer);
						SF_.theStandings.reloadTimer = null;
					}
				}
				return null;
			},
		sizeWidget: function()
			{
				if (SF_.inResize) return;
				SF_.inResize = true;
				var addtlScalar = 1;
				var newHeight;
				var newWidth;
				if (SF_.prefs.currentLeague in {"NCAAB":'',"FBS":''} && SF_.prefs.currentDisplay == "scoreboard")
					// adjust widget size to accommodate longer team names
					addtlScalar = 1.2; // use a standard width as the frequent resizing can become somewhat annoying
				$s("frontContent").left = $s("frontContent").right = "";
				if (SF_.prefs.useLargeFonts)
				{
					$s("front").fontSize = "14px";
					$s("info").right = $s("SportIcon").left = $s("quickSelect").left = (addtlScalar * 21) + "px";
					$s("info").bottom = $s("SportIcon").bottom = (addtlScalar * 23) + "px";
					$s("quickSelect").bottom = "40px";
					newHeight = 1.2 * _frontHeight;
					newWidth = addtlScalar * 1.2 * _frontWidth;
					$s("frontContent").left = (addtlScalar * 1.2 * $("frontContent").offsetLeft) + "px";
					$s("frontContent").right = (addtlScalar * 1.2 * parseInt(document.defaultView.getComputedStyle($("frontContent")).getPropertyValue("right"))) + "px";
				}
				else
				{
					$s("front").fontSize = $s("info").right = $s("SportIcon").left = $s("quickSelect").left = $s("quickSelect").bottom = "";
					$s("info").bottom = $s("SportIcon").bottom = (addtlScalar * 19) + "px";
					newWidth = addtlScalar * _frontWidth;
					newHeight = _frontHeight;
					$s("frontContent").left = (addtlScalar * $("frontContent").offsetLeft) + "px";
					$s("frontContent").right = (addtlScalar * parseInt(document.defaultView.getComputedStyle($("frontContent")).getPropertyValue("right"))) + "px";
				}
				if (SF_.prefs.currentLeague in {"NCAAB":'',"FBS":'',"NFL":''} && SF_.prefs.currentDisplay == "scoreboard")
				{
					var defaultHeight = SF_.prefs.currentSport == "Football" ? 162 : 149;
					$s("mainContent").height = ((SF_.prefs.useLargeFonts ? 1.2 : 1) * defaultHeight) + "px";
					var addtlVerticalSize = Math.max(0,$("mainContent").scrollHeight - $("mainContent").offsetHeight - 18);
					if (addtlVerticalSize > .33 * (SF_.prefs.useLargeFonts ? 1.2 : 1) * _frontHeight)
					{
						addtlVerticalSize = .33 * (SF_.prefs.useLargeFonts ? 1.2 : 1) * _frontHeight;
						$s("ContentScrollbar").visibility = "visible";
					}
					else
						$s("ContentScrollbar").visibility = "";
					$s("mainContent").height = "";
					newWidth = addtlScalar * (SF_.prefs.useLargeFonts ? 1.2 : 1) * _frontWidth;
					newHeight = addtlScalar * (SF_.prefs.useLargeFonts ? 1.2 : 1) * _frontHeight + addtlVerticalSize;
				}
				else if (SF_.prefs.currentDisplay == "scoreboard" && SF_.prefs.currentSport == "Baseball" && SF_.theScoreBoard.dates)
					$s("ContentScrollbar").visibility = SF_.theScoreBoard.dates.length && SF_.theScoreBoard.dates[0].games.length > 18 ? "visible" : "";
				else if (SF_.prefs.currentDisplay == "scoreboard")
					$s("ContentScrollbar").visibility = "";
				var startingRect = new AppleRect (0, 0, window.innerWidth, window.innerHeight);
				var finishingRect = new AppleRect (0, 0, newWidth, newHeight);
				var currentRectAnimation = new AppleRectAnimation(startingRect, finishingRect, SF_.doResize);
				var currentAnimator = new AppleAnimator (finishingRect.right - startingRect.right + finishingRect.bottom - startingRect.bottom > 8 ? 500 : 0, 13);
				currentAnimator.addAnimation(currentRectAnimation);
				currentAnimator.oncomplete = _resizeComplete;
				currentAnimator.start();
			},
		fadePopup: function(animation, current, start, finish)
			{
				$s("gameDetails").opacity = current;
			},
		showTeamPage: function(theTeam)
			{
				if (SF_.ignoreMouseUp) return;
				if (SF_.teams[SF_.prefs.currentLeague][theTeam].link)
					widget.openURL(SF_.teams[SF_.prefs.currentLeague][theTeam].link);
				else
				{
					switch (SF_.prefs.currentLeague)
					{
						case "NBA":
							widget.openURL("http://www.nba.com/" + SF_.teams["NBA"][theTeam].fullName.replace(/.* /,"").toLowerCase());
							break;
						case "WNBA":
							widget.openURL("http://www.wnba.com/" + (SF_.teams["WNBA"][theTeam].nickName || SF_.teams["WNBA"][theTeam].fullName.replace(/.* /,"").toLowerCase()));
							break;
						case "NCAAB":
							widget.openURL("http://www.sportsline.com/collegebasketball/teams/page/" + SF_.teams["NCAAB"][theTeam].shortName);
							break;
						case "FBS":
							widget.openURL("http://www.sportsline.com/collegefootball/teams/page/" + SF_.teams["FBS"][theTeam].shortName);
							break;
						case "MLB":
							widget.openURL("http://mlb.mlb.com/index.jsp?c_id=" + (SF_.teams["MLB"][theTeam].imgName || SF_.teams["MLB"][theTeam].shortName));
							break;
						case "AAA":
						case "AAX":
						case "AFA":
						case "AFX":
						case "ASX":
							widget.openURL("http://web.minorleaguebaseball.com/clubs/ip_index.jsp?cid=t" + SF_.teams[SF_.prefs.currentLeague][theTeam].imgName);
							break;
					}
				}
			},
		// we will replace these with the actual prototype functions later…
		_scoreBoard:
			function () {},
		_standings:
			function () {},
		// …and these get populated with real content separately
		teams:
			new Array(),
		defs:
			new Array(),
		leagues:
			new Array()
	}
})();

if (window.widget)
{
	widget.onremove = SF_.remove;
	widget.onhide = SF_.hide;
	widget.onshow = SF_.show;
	widget.ondragstart = SF_.closePopup;
}
window.onblur = SF_.closePopup;

//
